package hinesm.gazoushori.gazobottun;

import java.awt.Component;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Font;

public class GazoText extends GazoBottun
{
private boolean inputflg=false;
private int cursor=0;
private int mojisuu;
private int shownum;
private int stick=0;
private boolean stickflg=true;
private GazoText(int x,int y,Component c)
	{
super(x,y,c);
cnst(0);
	}
private GazoText(int x,int y,int width,int height,Component c)
	{
super(x,y,width,height,c);
cnst(0);
	}
public GazoText(int x,int y,Component c,int m)
	{
super(x,y,c);
cnst(m);
	}
public GazoText(int x,int y,int width,int height,Component c,int m)
	{
super(x,y,width,height,c);
cnst(m);
	}
public GazoText(int x,int y,String s,Component c)
	{
super(x,y,s,c);
cnst(0);
	}
public GazoText(int x,int y,int width,int height,String s,Component c)
	{
super(x,y,width,height,s,c);
cnst(0);
	}
public GazoText(int x,int y,String s,Component c,int m)
	{
super(x,y,s,c);
cnst(m);
	}
public GazoText(int x,int y,int width,int height,String s,Component c,int m)
	{
super(x,y,width,height,s,c);
cnst(m);
	}

private void cnst(int m)
	{
if(m<=0)
		{
notCursorMoveSetTitle("文字を入力してください");
setMojisuu(getTitle().length());
		}
else
		{
setMojisuu(m);
		}
	}
@Override
public void ifContainPerform(int mx,int my)
	{
if(containCheck(mx,my))
		{
perform();
		}
else
		{
inputflg=false;
		}
	}

public void notCursorMoveSetTitle(String s)
	{
super.setTitle(s);
	}
@Override
public void setTitle(String s)
	{
super.setTitle(s);
cursorMove(getCursor()*-1,0);
cursorMove(getTitle().length(),0);
	}

@Override
public void perform()
	{
inputflg=true;
	}

private void setMojisuu(int m)
	{
mojisuu=m;
shownum=0;
StringBuilder sb = new StringBuilder("a");
int cou = 1;
while(cou<m)
		{
sb.append("a");
cou=cou+1;
		}
titlefont = new Font(DEFAULT_FONT_STRING,DEFAULT_FONT_STYLE,getFontSize(difineFontDot(sb.toString(),getWidth(),getHeight())));
cursorMove(mojisuu,0);
	}

public void typing(KeyEvent e)
	{
int c=e.getKeyCode();
if(inputflg)
		{
switch(c)
			{
case KeyEvent.VK_RIGHT:
cursorMove(1,0);
break;
case KeyEvent.VK_LEFT:
/*
case KeyEvent.VK_UP:
break;
case KeyEvent.VK_DOWN:
break;
*/
cursorMove(-1,0);
break;
case KeyEvent.VK_BACK_SPACE:
if(title.length()>0 && getCursor()>0)
				{
notCursorMoveSetTitle(title.deleteCharAt(getCursor()-1).toString());
				}
cursorMove(-1,0);
break;
case KeyEvent.VK_ENTER:
inputflg=false;
break;
case KeyEvent.VK_SHIFT://ここから下はdefaultまで何も処理を行わない
;
break;
case KeyEvent.VK_FULL_WIDTH:
;
break;
case KeyEvent.VK_HALF_WIDTH:
;
break;
case KeyEvent.VK_HIRAGANA:
;
break;
case KeyEvent.VK_JAPANESE_HIRAGANA:
;
break;
case KeyEvent.VK_JAPANESE_KATAKANA:
;
break;
case KeyEvent.VK_JAPANESE_ROMAN:
;
break;
default:
notCursorMoveSetTitle(title.insert(getCursor(),e.getKeyChar()).toString());
cursorMove(1,0);
break;
			}
		}
	}
public int getCursor()
	{
return cursor;
	}

@Override
public void put(Graphics g)
	{
super.put(g);
g.setColor(getTitleColor());
if(stickflg)
			{
if(stick<=0)
		{
g.drawLine(getX()+(getFontDot()/4),getY(),getX()+(getFontDot()/4),getY()+getHeight());
		}
else if(stick>=mojisuu && mojisuu>=1)
		{
g.drawLine(getX()+((stick-1)*getFontDot())+(getFontDot()*3/4),getY(),getX()+((stick-1)*getFontDot())+(getFontDot()*3/4),getY()+getHeight());
		}
else
		{
g.drawLine(getX()+(stick*getFontDot()),getY(),getX()+(stick*getFontDot()),getY()+getHeight());
		}
if(!inputflg)
		{
stickflg=false;
		}
			}
else
			{
stickflg=true;
			}
g.setColor(gc);
	}

@Override
public void drawTitle(Graphics g)
	{
//文字を描きます
g.setFont(this.getTitleFont());
g.setColor(this.getTitleColor());
int cou=0;
if(titlestring!=null)
		{
while(mojisuu>cou && titlestring.length>shownum+cou)
			{
g.drawString(titlestring[shownum+cou],getX()+getFontDot()*cou,getY()+(getHeight()*3/4));
cou=cou+1;
			}
		}
g.setFont(gf);
	}

public void cursorMove(int right,int up)
	{
cursor=cursor+right;
stick=stick+right;
if(cursor<0)
		{
cursor=0;
stick=0;
		}
else if(cursor>title.toString().length())
		{
cursor=title.toString().length();
if(mojisuu>title.toString().length())
			{
stick=title.toString().length();
			}
else
			{
stick=mojisuu;
			}
		}

if(cursor<shownum)
		{
shownum=cursor;
stick=0;
		}
else if(cursor>shownum+mojisuu)
		{
shownum=cursor-mojisuu;
stick=mojisuu;
		}
	}

public boolean getInputFlag()
	{
return inputflg;
	}
}
