package hinesm.gazoushori.gazobottun;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Color;

public class RadioBottun extends GazoBottun
{
private int selection;
private RadioSelectionBottun[] RSB;
private MessageWindow MW;
private static final Color DEFAULT_SELECTION_COLOR = new Color(0xff7f7fff,true);
private static final Color DEFAULT_NOT_SELECTION_COLOR = new Color(0xffffffff,true); 
private int Line;
private int Haba;
//コンストラクタ
private RadioBottun(int x,int y,Component c)
	{
super(x,y,c);
	}
private RadioBottun(int x,int y,String s,Component c)
	{
super(x,y,s,c);
	}
private RadioBottun(int x,int y,int width,int height,Component c)
	{
super(x,y,width,height,c);
	}
private RadioBottun(int x,int y,int width,int height,String s,Component c)
	{
super(x,y,width,height,s,c);
	}
public RadioBottun(int x,int y,int width,int height,String s,Component c,String...ar)
	{
this(x,y,width,height,s,c,1,ar.length,ar);
	}
public RadioBottun(int x,int y,int width,int height,String s,Component c,int takasa,int nagasa,String... ar)
	{
//make instans
super(x,y,width,height,s,c);
if(takasa>0)
		{
Line=takasa;
		}
else
		{
Line=1;
		}

if(nagasa>0 || nagasa <= ar.length)
		{
Haba=nagasa;
		}
else
		{
Haba=ar.length;
		}

MW = MessageWindow.createMessageWindow(getX(),getY(),getWidth(),getHeight()/(Line+1),c,1,ar);
//setup radiobottun
MW.setFrameFlag(false);
int arc=0;
int rsbw=getWidth()/Haba;
RSB = new RadioSelectionBottun[ar.length];
while(ar.length>arc)
		{
RSB[arc] = new RadioSelectionBottun(getX()+(rsbw*arc)%(Haba*rsbw),getY()+((getHeight()+(getHeight()*(arc/Haba)))/(Line+1)),rsbw,(getHeight()/(Line+1)),ar[arc],c);
arc=arc+1;
		}
setSelection(0);
	}
//コンストラクタここまで
public String getRBTitle(int s)
	{
String ret = this.getTitle();
try
		{
if(s>=0 && RSB.length>s)
			{
ret = RSB[s].getTitle();
			}
		}
catch(Exception e)
		{
System.out.println(e);
		}
finally
		{
return ret;
		}
	}

public MessageWindow getTopMessage()
	{
return MW;
	}
	
@Override
public void put(Graphics g)
	{
g.setColor(getFrameColor());
g.drawRect(getX(),getY(),getWidth(),getHeight());
int i =0;
MW.put(g);
while(RSB.length>i)
			{
if(i==getSelection())
				{
RSB[i].setColor(RadioBottun.DEFAULT_SELECTION_COLOR);
				}
else
				{
RSB[i].setColor(RadioBottun.DEFAULT_NOT_SELECTION_COLOR);
				}
RSB[i].put(g);
i=i+1;
			}
g.setColor(gc);
	}
@Override
public void perform()
	{
System.out.println("Can not use this method,");
System.out.println("So Please use ifContainPerform(int my,int my)");
	}
private void setSelection(int s)
	{
if(s>=0)
		{
selection =s;
		}
else
		{
selection=0;
		}
MW.setNowMessage(selection+1);
	}
public int getSelection()
	{
return selection;
	}
@Override
public void ifContainPerform(int mx,int my)
	{
if(containCheck(mx,my))
		{
perform(mx,my);
		}
	}

public void perform(int x,int y)
	{
int srb = 0;
while(RSB.length>srb)
		{
if(RSB[srb].containCheck(x,y))
			{
setSelection(srb);
			}
srb=srb+1;
		}

	}
}
