package hinesm.game;

import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Color;
import java.util.ArrayList;
import java.awt.Toolkit;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.KeyEvent;
import hinesm.gazoushori.gazobottun.GazoText;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class STGPanel extends JPanel implements MouseListener
{
protected Graphics g;
protected Graphics dg;
protected Image img;
protected ArrayList<Ball> tama = new ArrayList<Ball>();
protected Target main;
protected int overtime=0;
private Font normalFont;
private Font bigFont;
boolean ret=true;
int strX=0;
int strY=0;
private static int time=0;
static int dif=0;

static StringBuilder LogSB;
static int ComNum = 0;
protected static boolean AUTO_FLG;
protected static GazoText LOG_GAZO_TEXT;

public STGPanel()
	{
addMouseListener(this);
addNotify();
	}
public void setMain()
	{
main= new Target(((getWidth()*3)/4),((getHeight()*3)/4),50,getWidth(),getHeight(),this);
	}
public void stgpaint(int mode)
	{
//if(g==null)
//		{
g=getGraphics();
//		}
if(g!=null)
		{
if(dg==null)
			{
img = createImage(getWidth(),getHeight());
dg = img.getGraphics();
			}
if(dg!=null)
			{
if(bigFont==null)
				{
bigFont = new Font(dg.getFont().getName(),dg.getFont().getStyle(),(dg.getFont().getSize()*3));
				}
if(normalFont==null)
				{
normalFont = new Font(dg.getFont().getName(),dg.getFont().getStyle(),(dg.getFont().getSize()));
				}
dg.setColor(Color.white);
dg.fillRect(0,0,getWidth(),getHeight());
dg.setColor(Color.black);
if(mode == -1)
				{
dg.drawString("上の入力欄にリプレイログファイル名を入力し、Enterキーを入れることでリプレイが再生されます。",0,getHeight()*2/3);
if(LOG_GAZO_TEXT ==null)
					{
LOG_GAZO_TEXT = new GazoText(getWidth()/3,getHeight()/3,180,20,"escapeLog.txt",this);
					}
if(LOG_GAZO_TEXT!=null)
					{
LOG_GAZO_TEXT.put(dg);
					}
				}
else if (mode==0)
				{
dg.setColor(Color.black);
dg.fillRect(0,0,getWidth(),getHeight());
dg.setColor(Color.red);
dg.drawString("PUSH ENTER START",0,getHeight()*3/4);
if(bigFont!=null)
					{
dg.setFont(bigFont);
					}
dg.drawString("ESCAPE FROM REAL",0,getHeight()/3);
if(normalFont!=null)
					{
dg.setFont(normalFont);
					}
				}
else if(mode==1)
				{
if(dif==1)
					{
dg.setColor(Color.lightGray);
dg.fillRect(0,0,getWidth(),getHeight());
dg.setColor(Color.black);

					}
if(AUTO_FLG)
					{
dg.drawString(Integer.toString((int)(getTime()+2)),10,10);
					}
if(dif==0)
					{
dg.drawString("現実から逃れなくては・・・！↑←↓→キーで・・・逃れなくては・・・！",getWidth()/3,getHeight()*3/4);
					}
else
					{
dg.drawString("なんでこんなこともできないんだ？",getWidth()/3,getHeight()*3/4);
					}
if(tama.size()>1)
					{
if(dif==0)
						{
dg.drawString("奴らは・・・5秒毎に増えている・・・！",getWidth()/10,getHeight()/3);
						}
else
						{
dg.drawString("もう帰っていいよ",getWidth()/10,getHeight()/3);
						}
if(tama.size()>2)
						{
if(dif==0)
							{
dg.drawString("避けたと思っても・・・壁にぶつかる度その時の俺の居場所へ直進するッ！",getWidth()/8,getHeight()*4/5);
							}
else
							{
dg.drawString("さっき言ったよね？",getWidth()/8,getHeight()*4/5);
							}
if(tama.size()>3)
							{
if(dif==0)
								{
dg.drawString("いつまでだ・・・！？いつまで俺はあの辛い現実から逃げられるんだ・・・！？",getWidth()/3,getHeight()/4);
								}
else
								{
dg.drawString("これやってね。あれもやってね。それもお願い",getWidth()/3,getHeight()/4);
								}				
if(tama.size()>24)
								{
if(bigFont!=null)
									{
dg.setFont(bigFont);
									}
if(dif==0)
									{
dg.drawString("俺のそばに近寄るなアアァァーッ！",0,getHeight()/2);
									}
else
									{
dg.drawString("もう何もやりたくない・・・",0,getHeight()/2);
									}
if(normalFont!=null)
									{
dg.setFont(normalFont);
									}
								}
							}
						}
					}
int cou=0;
while(tama.size()>cou)
					{
tama.get(cou).draw(dg);
cou=cou+1;
					}
if(main!=null)
					{
main.draw(dg);
					}
				}
else if(mode==2)
				{
dg.setColor(Color.black);
dg.fillRect(0,0,getWidth(),getHeight());
dg.setColor(Color.red);
if(bigFont!=null)
					{
dg.setFont(bigFont);
					}
dg.drawString("GAME OVER",(getWidth()/4),(getHeight()/3));
if(normalFont!=null)
					{
dg.setFont(normalFont);
					}
if(time>2400)
					{
dg.drawString("INPUT TO KEY 'HARD' IN THE TITLE",0,60);
					}
dg.drawString("例え現実から"+time/20+"秒逃げられたとしても、いつかは追いつかれる",0,getHeight()*2/3);
/*
if(!(AUTO_FLG))
					{
dg.drawString("このまましばらく放置すると、escapeLog.txtというファイル名で今回のリプレイを記録します。",0,getHeight()*3/4);
dg.drawString("そのリプレイはタイトル画面で'REP'と入力すると再生することができます",0,getHeight()*5/6);
					}
*/
				}
g.drawImage(img,0,0,null);
g.dispose();
			}
		}
	}
public void AddLog(int n)
	{
ComNum=ComNum+4;
LogSB.append(ComNum);
	}
/*
public void readLog()
	{
if(AUTO_FLG)
		{
try
			{
main.commandMove(onore.Command.charAt(time+1));
			}
catch(arrayIndexOutOfBoundsExceptinon e)
			{
main.commandMove(4);
			}
		}
	}
*/
public boolean shori(int mode)
	{
if(mode==-1)
		{
		}
else if(mode==0)
		{
if(AUTO_FLG)
			{
switch(onore.Command.charAt(0))
				{
case 'h':
System.out.println("numa");
onore.dif=15;
difineDif();
break;
default:
onore.dif=0;
difineDif();
break;
				}
onore.mode=1;
System.out.println(dif);
			}
		}
else if(mode == 1)
		{
//readLog();
if(main!=null)
			{
AddLog(ComNum);
ret=true;
if(AUTO_FLG)
				{
ret = main.move();
				}
if(time%100 == 0 && tama.size()<100)
				{
tama.add(new Ball(this,main,5,4));
				}
int cou=0;
while(tama.size()>cou)
				{
tama.get(cou).move();
cou=cou+1;
				}
if(!(AUTO_FLG))
				{
ret = main.move();
				}
time=time+1;
			}
		}
else if(mode==2)
		{
if(overtime==1)
			{
LogSB.append("e");
			}
overtime=overtime+1;
		}
return ret;
	}
protected void difineDif()
	{
switch(onore.dif)
		{
case 15:
LogSB=new StringBuilder("h");
STGPanel.dif=1;
break;
default:
LogSB=new StringBuilder("n");
STGPanel.dif=0;
break;
		}
	}

public void ComNumPlus(int n)
	{
ComNum=ComNum+n;
	}
public int getTime()
	{
return time;
	}

public void getKeyReleased(KeyEvent e,onore on)
	{
if(onore.mode==-1 && LOG_GAZO_TEXT!=null)
		{
LOG_GAZO_TEXT.typing(e);
if(e.getKeyCode()==KeyEvent.VK_ENTER)
			{
onore.loadCommand(LOG_GAZO_TEXT.getTitle(),on);
			}
		}
	}
public void mousePressed(MouseEvent e)
	{
;
	}
public void mouseReleased(MouseEvent e)
	{
if(onore.mode==-1 && LOG_GAZO_TEXT!=null)
		{
LOG_GAZO_TEXT.ifContainPerform(e.getX(),e.getY());
		}
	}
public void mouseClicked(MouseEvent e)
	{
;
	}
public void mouseEntered(MouseEvent e)
	{
;
	}
public void mouseExited(MouseEvent e)
	{
;
	}
}
